               JOB  HZG DEMO                                               SGSVU
               CTL  6611
     *
     * CONTROL CARD LAYOUT
     *
     I3LEN     EQU  4    1-4     TAPE 3 RECORD LENGTH
     I3WMAX    EQU  8    6-8     TAPE 3 RECORDS UNTIL REWIND
     I3PMAX    EQU  11   10-11   TAPE 3 PROCESSING DELAY
     I3RDLY    EQU  16   13-16   TAPE 3 REWIND DELAY
     I4LEN     EQU  21   18-21   TAPE 4 RECORD LENGTH
     I4WMAX    EQU  25   23-25   TAPE 4 RECORDS UNTIL REWIND
     I4PMAX    EQU  28   27-28   TAPE 4 PROCESSING DELAY
     I4RDLY    EQU  33   30-33   TAPE 4 REWIND DELAY
     I5LEN     EQU  38   35-38   TAPE 5 RECORD LENGTH
     I5WMAX    EQU  42   40-42   TAPE 5 RECORDS UNTIL REWIND
     I5PMAX    EQU  45   44-45   TAPE 5 PROCESSING DELAY
     I5RDLY    EQU  50   47-50   TAPE 5 REWIND DELAY
     I6LEN     EQU  55   52-55   TAPE 6 RECORD LENGTH
     I6WMAX    EQU  59   57-59   TAPE 6 RECORDS UNTIL REWIND
     I6PMAX    EQU  62   61-62   TAPE 6 PROCESSING DELAY
     I6RDLY    EQU  67   64-67   TAPE 6 REWIND DELAY
     IRDLY     EQU  72   69-72   FULL REEL TAPE REWIND DELAY
     IDDLY     EQU  75   74-75   DISK PROCESSING DELAY
     IDPSW     EQU  80           PRINT DISK ADDRESSES IF NON BLANK
     *
               ORG  81           RECORD MARK AT 81 WILL BE
               DC   @'@          SENTINEL AFTER LAST LINE OF IMAGE
     KP1       DCW  &1
     KB        DCW  #1           CHANGES BSS C TO BRANCH
     KC        DCW  @C@          CHANGES BRANCH TO BSS C
               DC   @..@
     X1        DCW  081
               DC   @..@
     X2        DCW  010
               DC   @..@
     X3        DCW  000
     GMWM      DCW  @"@
               ORG  336
     *
     * LOAD PARAMETERS
     *
     START     R
               MCW  I3RDLY,T3RDLY      TAPE 3 REWIND DELAY
               MCW                     TAPE 3 PROCESSING DELAY
               MCW                     TAPE 3 RECORDS UNTIL REWIND
               MCW  I4RDLY,T4RDLY      TAPE 4 REWIND DELAY
               MCW                     TAPE 4 PROCESSING DELAY
               MCW                     TAPE 4 RECORDS UNTIL REWIND
               MCW  I5RDLY,T5RDLY      TAPE 5 REWIND DELAY
               MCW                     TAPE 5 PROCESSING DELAY
               MCW                     TAPE 5 RECORDS UNTIL REWIND
               MCW  I6RDLY,T6RDLY      TAPE 6 REWIND DELAY
               MCW                     TAPE 6 PROCESSING DELAY
               MCW                     TAPE 6 RECORDS UNTIL REWIND
               MCW  IRDLY,RDELAY       REWIND FULL TAPE DELAY COUNT
               MCW  IDDLY,DCNTI        DISK DELAY COUNT
     *
     * CALCULATE TAPE WRITE ADDRESSES FROM RECORD LENGTHS
     *
               B    GETOFF             CALULATE OFFSET = - I3LEN
               DSA  I3LEN              TAPE 3 RECORD LENGTH
               DSA  TAPE3W&6           TAPE 3 WRITE INSTRUCTION
               B    GETOFF             CALULATE OFFSET = - I4LEN
               DSA  I4LEN              TAPE 4 RECORD LENGTH
               DSA  TAPE4W&6           TAPE 4 WRITE INSTRUCTION
               B    GETOFF             CALULATE OFFSET = - I5LEN
               DSA  I5LEN              TAPE 5 RECORD LENGTH
               DSA  TAPE5W&6           TAPE 5 WRITE INSTRUCTION
               B    GETOFF             CALULATE OFFSET = - I6LEN
               DSA  I6LEN              TAPE 6 RECORD LENGTH
               DSA  TAPE6W&6           TAPE 6 WRITE INSTRUCTION
     *
               SW   1
               BCE  RLOOP,IDPSW,       IS IDPSW BLANK?
               MCW  NOP,DISKB          TURN ON DISK ADDRESS PRINTING
     *
               B    RDIMAG             READ AND STORE THE IMAGE
     *
     * EVENT LOOP -- CHECK SWITCHES TO DETERMINE ACTIONS
     *
     SWLOOP    BSS  PRINT,C            D-MOD CHANGED BY PRINT TO BLANK
               BSS  DISK,B             EXERCISE 1311
               BSS  TAPEX,D            EXERCISE TAPE 3
     NOP       NOP  T3PAKT
               BSS  TAPEX,E            EXERCISE TAPE 4
               NOP  T4PAKT
               BSS  TAPEX,F            EXERCISE TAPE 5
               NOP  T5PAKT
               BSS  TAPEX,G            EXERCISE TAPE 6
               NOP  T6PAKT
               B    SWLOOP
               JOB  HZG DEMO -- 1311 DISK EXERCISER                        SGSVU
     *
     * 1311 DISK EXERCISER
     *
     DISK      SBR  DISKX&3
               BWZ  DISKA,DCOUNT,K     IS THE COUNT NEGATIVE?
               S    KP1,DCOUNT         SUBTRACT ONE FROM THE COUNT
               B    DISKX              GO TO SUBR EXIT
     DISKA     LCA  DK2,DMUL           A CRUDE MULTIPLICATIVE RNG
               M    DFAC,DPROD
               MCW  DPROD,DK2
               LCA  KONE,DADDR1
               MCW  DK1,DADDR1
               A    DADDR1
               MCW  KONE,DADDR2
               MCW  %F0,DADDR,R        SEEK DISK
               MCW  DCNTI,DCOUNT          
     DISKB     B    DISKX              SKIP PRINTING DISK ADDRESSES
               MCW  DK1,200&X2         MOVE DISK ADDRESS TO PRINT AREA
               BCE  DISKW,X2-2,1       INDEX HIGH-ORDER DIGHT 1?
               B    DISKY              NO
     DISKW     W                       YES, WRITE THE ADDRESSES
               CS
               CS
               SBR  X2,0               CLEAR INDEX
     DISKY     SBR  X2,10&X2           ADD TEN TO INDEX
     DISKX     B    0
     *
     DMUL      DCW  0000
     DPROD     DC   000
     DK1       DCW  91
     DK2       DC   57
     DFAC      DCW  83
     DADDR     DC   @*@
     DADDR1    DC   0000
     DADDR2    DC   00001
     KZERO     DCW  000                CONSTANT ZERO
     KONE      DCW  001
     DCNTI     DCW  00                 INITIAL DISK DELAY COUNT
     DCOUNT    DCW  01                 CURRENT DISK DELAY COUNT
               JOB  HZG DEMO -- PRINT THE PICTURE                          SGSVU
     *
     * READ THE IMAGE AND STORE IT.  THE FIRST CHARACTER AFTER THE LAST
     * ONE IN THE STORAGE AREA WILL BE A RECORD MARK.
     *
     RDIMAG    SBR  RDEXIT&3
     RLOOP     R
               LCA  81,IMAGE&X1        STORE ONE LINE OF THE IMAGE
               B    GOTEM,A            DONE?
               SBR  X1,80&X1           ADD 80 TO X1
               B    RLOOP              GET ANOTHER ONE
     *
     GOTEM     SBR  X1,80              RESET X1 TO 80
               CS   332
               CS
               CC   1
     RDEXIT    H    0                  WAIT FOR THE SWITCHES TO BE SET
     *
     * PRINT THE PICTURE
     *
     PRINT     SBR  PRINTX&3
               MCW  KB,SWLOOP&4        MAKE ENTRY TEST UNCONDITIONAL
               LCA  IMAGE&X1,306
               W
               B    PRINTA,IMAGE&1&X1,'  LAST IMAGE?   
               SBR  X1,80&X1           ADD 80 TO X1
               B    PRINTX
     PRINTA    SBR  X1,80              RESET X1 TO 80
               CC   1
               MCW  KC,SWLOOP&4        CHANGE ENTRY TEST TO BSS C
     PRINTX    B    0
               JOB  HZG DEMO -- TAPE EXERCISER                             SGSVU
     *
     * TAPE EXERCISER PACKET LAYOUT
     *
     TWMAX     EQU  2&X3    NUMBER OF RECORDS INITIAL VALUE
     TPMAX     EQU  5&X3    PROCESSING DELAY INITIAL VALUE
     TRDLY     EQU  10&X3   REWIND DELAY INITIAL VALUE
     TWRIT     EQU  18&X3   TAPE WRITE INSTRUCTION LAST CHAR
     TPCNT     EQU  20&X3   CURRENT PROCESSING DELAY COUNT
     TWCNT     EQU  23&X3   CURRENT RECORDS UNTIL REWIND
     TRCNT     EQU  27&X3   CURRENT REWIND DELAY COUNT
     *
     * TAPE EXERCISER.  FOLLOW  B TAPEX  WITH  NOP PACKET
     *
     TAPEX     SBR  TAPEXX&3
               SBR  X3
               MCW  4&X3,X3            ADDRESS OF PACKET TO X3
               BWZ  TAPEXA,TRCNT,K     ENOUGH REWIND DELAY?
               S    KP1,TRCNT
               B    TAPEXX
     TAPEXA    C    KONE,TPCNT         ENOUGH PROCESSING DELAY?
               BE   TAPEXB
               S    KP1,TPCNT          DECR PROCESSING DELAY COUNT
               MZ   KZERO,TPCNT
               B    TAPEXX
     TAPEXB    LCA  TRDLY,TRCNT        RWD DELAY DEPENDING ON REC CNT
               BWZ  TAPEXE,TWCNT,K     TIME TO REWIND?
               LCA  RDELAY,TRCNT       DELAY FOR FULL REEL REWIND
               BEF  TAPEXE
               LCA  KM1,TRCNT          SET FOR NO REWIND DELAY
               MCW  TWRIT,*&8          COPY TAPE WRITE INSTRUCTION
               WT   3,GMWM
               S    KP1,TWCNT          DECREMENT WRITE COUNTER
               MCW  TPMAX,TPCNT        STORE PROCESSING DELAY
     TAPEXX    B    0
     TAPEXE    MN   TWRIT-4,*&4        SET DRIVE NUMBER IN REWIND
               RWD  3
               MCW  TWMAX,TWCNT        RE-INITIALIZE WRITE COUNT
               B    TAPEXX
     *
     * OFFSET THE TAPE WRITE ADDRESS, GIVEN THE RECORD LENGTH
     * DO THIS BY MA-ING THE 16000-COMPLEMENT OF THE RECORD
     * LENGTH TO THE ADDRESS IN THE TAPE WRITE INSTRUCTION
     *
     GETOFF    SBR  X3
               SBR  GETXX&3,7&X3
               LCA  P16K,ROFF          START WITH 16001
               MCW  3&X3,*&4           ADDRESS OF RECORD LENGTH
               S    0,ROFF             DECREASE BY RECORD LENGTH
               MZ   KZERO,ROFF         CLEAR ZONE
     GETL      S    KP1,RTHOU
               BWZ  GETX,RTHOU,K       DONE?
               MA   K1000,ROFF         ADD 1000 TO OFFSET
               B    GETL 
     GETX      MCW  6&X3,X3            ADDRESS OF TAPE WRITE
               CS   0                  GET LAST ADDRESS TO BE REG
               LCA  GMWM               GMWM TO TOP OF MEMORY
               SBR  0&X3               LAST ADDRESS IN MEMORY - 1
               MA   ROFF,0&X3          SUBTRACT RECORD LENGTH
     GETXX     B    0
     *
     RLEN      DCW  0000               RECORD LENGTH
     RTHOU     DCW  00                 THOUSANDS PART OF OFFSET
     ROFF      DC   000                OFFSET TO TAPE ADDRESS = - RLEN
     K1000     DSA  1000               ADDRESS CONSTANT 1000
     P16K      DCW  16001
     *
     * TAPE EXERCISER CONTROL PACKETS
     *
     T3PAKT    DCW  000     NUMBER OF RECORDS INITIAL VALUE
               DC   #1      FILLER FROM CONTROL CARD
               DCW  00      PROCESSING DELAY INITIAL VALUE
               DC   #1      FILLER FROM CONTROL CARD
     T3RDLY    DCW  0000    REWIND DELAY INITIAL VALUE
     TAPE3W    WT   3,0     TAPE WRITE INSTRUCTION
               DCW  00      CURRENT PROCESSING DELAY COUNT
               DCW  000     CURRENT RECORDS UNTIL REWIND
               DCW  -0001   CURRENT REWIND DELAY COUNT
     *
     T4PAKT    DCW  000     NUMBER OF RECORDS INITIAL VALUE
               DC   #1      FILLER FROM CONTROL CARD
               DCW  00      PROCESSING DELAY INITIAL VALUE
               DC   #1      FILLER FROM CONTROL CARD
     T4RDLY    DCW  0000    REWIND DELAY INITIAL VALUE
     TAPE4W    WT   4,0     TAPE WRITE INSTRUCTION
               DCW  00      CURRENT PROCESSING DELAY COUNT
               DCW  000     CURRENT RECORDS UNTIL REWIND
               DCW  -0001   CURRENT REWIND DELAY COUNT
     *
     T5PAKT    DCW  000     NUMBER OF RECORDS INITIAL VALUE
               DC   #1      FILLER FROM CONTROL CARD
               DCW  00      PROCESSING DELAY INITIAL VALUE
               DC   #1      FILLER FROM CONTROL CARD
     T5RDLY    DCW  0000    REWIND DELAY INITIAL VALUE
     TAPE5W    WT   5,0     TAPE WRITE INSTRUCTION
               DCW  00      CURRENT PROCESSING DELAY COUNT
               DCW  000     CURRENT RECORDS UNTIL REWIND
               DCW  -0001   CURRENT REWIND DELAY COUNT
     *
     T6PAKT    DCW  000     NUMBER OF RECORDS INITIAL VALUE
               DC   #1      FILLER FROM CONTROL CARD
               DCW  00      PROCESSING DELAY INITIAL VALUE
               DC   #1      FILLER FROM CONTROL CARD
     T6RDLY    DCW  0000    REWIND DELAY INITIAL VALUE
     TAPE6W    WT   6,0     TAPE WRITE INSTRUCTION
               DCW  00      CURRENT PROCESSING DELAY COUNT
               DCW  000     CURRENT RECORDS UNTIL REWIND
               DCW  -0001   CURRENT REWIND DELAY COUNT
     *
     RDELAY    DCW  0000    DELAY COUNTER FOR EOT REWINDS
     KM1       DCW  -0001   CONSTANT -1
     *
     IMAGE     DS   1       STORAGE FOR IMAGE STARTS HERE
               END  START
